Index: trunk/sources/HeuristicLab 3.3 Services.sln
===================================================================
--- trunk/sources/HeuristicLab 3.3 Services.sln	(revision 7169)
+++ trunk/sources/HeuristicLab 3.3 Services.sln	(revision 7170)
@@ -16,6 +16,4 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Services.Deployment-3.3.Tests", "HeuristicLab.Services.Deployment\3.3\Tests\HeuristicLab.Services.Deployment-3.3.Tests.csproj", "{421D9CCA-5A48-4813-AB9C-ED7025F9CC35}"
-EndProject
-Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Hive", "Hive", "{C159ED4A-0E0C-4CCC-81B4-F8979F5C3CE1}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Services.Hive.DataAccess-3.3", "HeuristicLab.Services.Hive.DataAccess\3.3\HeuristicLab.Services.Hive.DataAccess-3.3.csproj", "{EC2C8109-6E1E-4C88-9A2B-908CFF2EF4AC}"
@@ -129,8 +127,3 @@
 		HideSolutionNode = FALSE
 	EndGlobalSection
-	GlobalSection(NestedProjects) = preSolution
-		{EC2C8109-6E1E-4C88-9A2B-908CFF2EF4AC} = {C159ED4A-0E0C-4CCC-81B4-F8979F5C3CE1}
-		{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE} = {C159ED4A-0E0C-4CCC-81B4-F8979F5C3CE1}
-		{0CA6706D-A569-45DE-A85C-4158891CC1BC} = {C159ED4A-0E0C-4CCC-81B4-F8979F5C3CE1}
-	EndGlobalSection
 EndGlobal
Index: trunk/sources/HeuristicLab 3.3.sln
===================================================================
--- trunk/sources/HeuristicLab 3.3.sln	(revision 7169)
+++ trunk/sources/HeuristicLab 3.3.sln	(revision 7170)
@@ -256,9 +256,5 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.QuadraticAssignment.Algorithms-3.3", "HeuristicLab.Problems.QuadraticAssignment.Algorithms\3.3\HeuristicLab.Problems.QuadraticAssignment.Algorithms-3.3.csproj", "{5B9B9E8C-2706-43C2-80B8-A08341E431F7}"
 EndProject
-Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Tests", "Tests", "{C89ADA03-1DAC-406A-9C1F-128CC9986D80}"
-EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Tests", "HeuristicLab.Tests\HeuristicLab.Tests.csproj", "{B62872C1-6752-4758-9823-751A2D28C388}"
-EndProject
-Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Hive", "Hive", "{40362A4B-25F8-48AC-AFB1-645E6F4226A9}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Hive-3.3", "HeuristicLab.Hive\3.3\HeuristicLab.Hive-3.3.csproj", "{F98A1740-9AC9-4D36-A582-6A2D0D06978D}"
@@ -1337,11 +1333,3 @@
 		HideSolutionNode = FALSE
 	EndGlobalSection
-	GlobalSection(NestedProjects) = preSolution
-		{B62872C1-6752-4758-9823-751A2D28C388} = {C89ADA03-1DAC-406A-9C1F-128CC9986D80}
-		{F98A1740-9AC9-4D36-A582-6A2D0D06978D} = {40362A4B-25F8-48AC-AFB1-645E6F4226A9}
-		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB} = {40362A4B-25F8-48AC-AFB1-645E6F4226A9}
-		{E1D6C801-892A-406A-B606-F158E36DD3C3} = {40362A4B-25F8-48AC-AFB1-645E6F4226A9}
-		{DBFD7205-61AF-40EF-8776-3052DEF91CF3} = {40362A4B-25F8-48AC-AFB1-645E6F4226A9}
-		{5211F1AD-BBA2-4C62-8749-DCA0A25CF5D8} = {40362A4B-25F8-48AC-AFB1-645E6F4226A9}
-	EndGlobalSection
 EndGlobal
Index: trunk/sources/HeuristicLab.ExtLibs.sln
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs.sln	(revision 7169)
+++ trunk/sources/HeuristicLab.ExtLibs.sln	(revision 7170)
@@ -2,20 +2,4 @@
 Microsoft Visual Studio Solution File, Format Version 11.00
 # Visual Studio 2010
-Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "ALGLIB", "ALGLIB", "{FD1153D2-8F09-4A70-9554-0F609D41A141}"
-EndProject
-Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "DayView", "DayView", "{6A8FEB09-F65C-4144-9D29-63576DE65F19}"
-EndProject
-Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "LibSVM", "LibSVM", "{B757C121-C164-4EE7-9171-E3D7D1091784}"
-EndProject
-Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "log4net", "log4net", "{22D63D2F-3361-433F-8812-EEE2E3C895A1}"
-EndProject
-Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Netron", "Netron", "{CA1AF84C-3F10-44EB-BE55-56EC9F107129}"
-EndProject
-Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "ProtoBufCS", "ProtoBufCS", "{B2FF4217-8D75-4D83-843A-605F641413BD}"
-EndProject
-Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "SharpDevelop", "SharpDevelop", "{ACB544FB-A20C-441B-A40E-CA97DE0644EF}"
-EndProject
-Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "WinFormsUI", "WinFormsUI", "{CF0D768B-4036-4D9A-8B10-EF724910399B}"
-EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "ALGLIB-3.1.0", "HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\3.1.0\ALGLIB-3.1.0\ALGLIB-3.1.0.csproj", "{FC841674-62A7-4055-BE91-E41944B6C606}"
 EndProject
@@ -247,20 +231,4 @@
 		HideSolutionNode = FALSE
 	EndGlobalSection
-	GlobalSection(NestedProjects) = preSolution
-		{FC841674-62A7-4055-BE91-E41944B6C606} = {FD1153D2-8F09-4A70-9554-0F609D41A141}
-		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6} = {FD1153D2-8F09-4A70-9554-0F609D41A141}
-		{02766ECC-D0F5-4115-9ECA-47409167B638} = {6A8FEB09-F65C-4144-9D29-63576DE65F19}
-		{89B50302-9CEE-4D13-9779-633EADCAE624} = {B757C121-C164-4EE7-9171-E3D7D1091784}
-		{A16F23B5-FB62-499E-A831-26953AA56FE2} = {B757C121-C164-4EE7-9171-E3D7D1091784}
-		{1B3063DB-D71C-4A6A-A359-883E8F53A140} = {22D63D2F-3361-433F-8812-EEE2E3C895A1}
-		{BB994448-2B21-4564-BB2E-38D8FFF8CF18} = {CA1AF84C-3F10-44EB-BE55-56EC9F107129}
-		{96AEBBEE-4203-45F3-BCF5-7B73BF256BDA} = {CA1AF84C-3F10-44EB-BE55-56EC9F107129}
-		{236459CE-80CF-4991-972F-DE74C826BCCC} = {B2FF4217-8D75-4D83-843A-605F641413BD}
-		{250ADE34-82FD-4BAE-86D5-985FBE589C4A} = {B2FF4217-8D75-4D83-843A-605F641413BD}
-		{6908BDCE-D925-43F3-94AC-A531E6DF2591} = {B2FF4217-8D75-4D83-843A-605F641413BD}
-		{4ABA047D-46DD-4608-9E4A-41C5F92FDBB1} = {ACB544FB-A20C-441B-A40E-CA97DE0644EF}
-		{678E2145-8152-4E19-9646-07D439D00301} = {CF0D768B-4036-4D9A-8B10-EF724910399B}
-		{1849A92E-DCFC-4E05-BB0A-D7B7A3DAFCFB} = {CF0D768B-4036-4D9A-8B10-EF724910399B}
-	EndGlobalSection
 	GlobalSection(SubversionScc) = preSolution
 		Svn-Managed = True